#include <swift/atomic.h>

void swift_init_ref(swift_ref_t *ref)
{
	swift_atomic_set(&ref->count, 1);
}

void swift_acquire_ref(swift_ref_t *ref)
{
	swift_atomic_inc(&ref->count);
}

bool swift_acquire_ref_unless_zero(swift_ref_t *ref)
{
	return swift_atomic_add_unless(&ref->count, 1, 0);
}

void swift_release_ref(swift_ref_t *ref, swift_release_ref_func_t release)
{
	if (swift_atomic_dec_test(&ref->count))
		release(ref);
}
