#include <swift/data.h>

uint32_t swift_fnv1_hash32(const void *data_, size_t size)
{
	const char *data;
	uint32_t hash = SWIFT_FNV32_OFFSET;

	for (data = (const char *)data_; *data; ++data)
		hash = (hash * SWIFT_FNV32_PRIME) ^ *data;

	return hash;
}

uint32_t swift_fnv1a_hash32(const void *data_, size_t size)
{
	const char *data;
	uint32_t hash = SWIFT_FNV32_OFFSET;

	for (data = (const char *)data_; *data; ++data)
		hash = (hash ^ *data) * SWIFT_FNV32_PRIME;

	return hash;
}

uint64_t swift_fnv1_hash64(const void *data_, size_t size)
{
	const char *data;
	uint64_t hash = SWIFT_FNV64_OFFSET;

	for (data = (const char *)data_; *data; ++data)
		hash = (hash * SWIFT_FNV64_PRIME) ^ *data;

	return hash;
}

uint64_t swift_fnv1a_hash64(const void *data_, size_t size)
{
	const char *data;
	uint64_t hash = SWIFT_FNV64_OFFSET;

	for (data = (const char *)data_; *data; ++data)
		hash = (hash ^ *data) * SWIFT_FNV64_PRIME;

	return hash;
}
