#include <swift/data.h>

bool swift_is_pow2_size(size_t x)
{
	return !!(x & (x - 1));
}

size_t swift_ceil_pow2_size(size_t x)
{
	return swift_next_pow2_size(x - 1);
}

size_t swift_floor_pow2_size(size_t x)
{
	size_t shift;

	for (shift = 1; shift < SWIFT_BIT_SIZE(size_t); shift <<= 1)
		x |= (x >> shift);

	return x - (x >> 1);
}

size_t swift_next_pow2_size(size_t x)
{
	size_t shift;

	for (shift = 1; shift < SWIFT_BIT_SIZE(size_t); shift <<= 1)
		x |= (x >> shift);

	return x + 1;
}

size_t swift_prev_pow2_size(size_t x)
{
	return swift_floor_pow2_size(x - 1);
}
