#ifndef NATIVE_LOOP_H
#define NATIVE_LOOP_H

#include <swift/stdlib.h>

typedef struct swift_ev_loop_t swift_ev_loop_t;

struct swift_ev_loop_t {
	swift_list_t msgs;
	swift_htable_t *srcs;
	swift_thread_id_t thread_id;
};

size_t swift_hash_ev_loop(const void *data);
bool swift_eq_ev_loops(const void *lhs_, const void *rhs_);
swift_ev_loop_t *swift_new_ev_loop(swift_thread_id_t thread_id);
void swift_del_ev_loop(swift_ev_loop_t *loop);
swift_ev_loop_t *swift_get_ev_loop(swift_thread_id_t thread_id);
swift_ev_loop_t *swift_get_cur_ev_loop(void);
bool swift_init_main_ev_loop(void);

#endif /* NATIVE_LOOP_H */
