#ifndef SWIFT_GUI_CONTROLS_H
#define SWIFT_GUI_CONTROLS_H

#include <swift/gui/api.h>
#include <swift/gui/widget.h>

typedef enum swift_control_t swift_control_t;

enum swift_control_t {
	SWIFT_CONTROL_EMPTY = 0,
	SWIFT_CONTROL_BUTTON = 1,
	SWIFT_CONTROL_LABEL = 2,
	SWIFT_CONTROL_WINDOW = 3,
	SWIFT_CONTROL_SCREEN = 4,
	SWIFT_CONTROL_CHECKBOX = 5,
	SWIFT_CONTROL_RADIO = 6,
	SWIFT_CONTROL_PICTUREBOX = 7,
	SWIFT_CONTROL_HSCROLL_BAR = 8,
	SWIFT_CONTROL_VSCROLL_BAR = 9,
	SWIFT_CONTROL_HPROGRESSBAR = 10,
	SWIFT_CONTROL_VPROGRESSBAR = 11,
	SWIFT_CONTROL_LISTBOX = 12,
	SWIFT_CONTROL_TEXTBOX = 13,
	SWIFT_CONTROL_FRAME = 14,
	SWIFT_CONTROL_CLIPBOX = 15,
	SWIFT_CONTROL_STATUSBOX = 16,
	SWIFT_CONTROL_CHATBOX = 17,
	SWIFT_CONTROL_ROOT = 18,
	SWIFT_CONTROL_MAX = 19
};

SWIFT_GUI_API void swift_unload_base(swift_widgets_t *wgts,
	swift_widget_t *control);
SWIFT_GUI_API void swift_unload_base2(swift_widgets_t *wgts,
	swift_widget_t *control);
SWIFT_GUI_API void swift_handle_control_move(swift_widgets_t *wgts,
		swift_widget_t *control);
SWIFT_GUI_API void swift_draw_base(swift_widgets_t *wgts,
	swift_widget_t *control);
#endif /*SWIFT_GUI_CONTROLS_H*/
