#ifndef SWIFT_GUI_SCROLLBAR_H
#define SWIFT_GUI_SCROLLBAR_H

#include <swift/gui/api.h>
#include <swift/gui/widget.h>
#include <swift/string.h>

typedef struct swift_scrollbar_t swift_scrollbar_t;

struct swift_scrollbar_t {
	swift_widget_t btn1, btn2, bar;
};

SWIFT_GUI_API void swift_create_hscrollbar(swift_widget_t *control,
	swift_widget_t *parent, swift_vec3f_t pos, swift_vec2f_t hw,
		swift_vec2f_t button_hw, size_t value, size_t max_value,
			swift_str_t *bkgd, swift_str_t *btnl, swift_str_t *btnr,
				swift_str_t *bar, bool visible);
SWIFT_GUI_API void swift_set_scrollbar_buttons_mouse_down(
	swift_widget_t *control, swift_control_mouse_down callback);
SWIFT_GUI_API void swift_hscrollbar_value_reset(swift_widget_t *control,
	size_t value, size_t maxvalue);
SWIFT_GUI_API void swift_create_vscrollbar(swift_widget_t *control,
	swift_widget_t *parent, swift_vec3f_t pos, swift_vec2f_t hw,
		swift_vec2f_t button_hw, size_t value, size_t max_value,
			swift_str_t *bkgd, swift_str_t *btnt, swift_str_t *btnb,
				swift_str_t *bar, bool visible);
SWIFT_GUI_API void swift_vscrollbar_value_reset(swift_widget_t *control,
	size_t value, size_t maxvalue);
#endif /*SWIFT_GUI_SCROLLBAR_H*/
