#include <swift/gui.h>
#include <swift/window.h>

static void swift_draw_clipbox(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	swift_set_clip_box(wgts->window, SWIFT_VEC4F(control->sprite.pos.xyz.x,
		wgts->window->screen_box.xywh.h - control->sprite.pos.xyz.y -
			control->sprite.size.wh.h, control->sprite.pos.xyz.x +
				control->sprite.size.wh.w, wgts->window->screen_box.xywh.h -
					control->sprite.pos.xyz.y));

	control->draw(wgts, control);
	swift_set_clip_box(wgts->window, wgts->window->screen_box);
}

void swift_create_clipbox(swift_widget_t *control, swift_widget_t *parent,
	swift_vec3f_t pos, swift_vec2f_t hw, bool visible)
{
	swift_init_widget(control);
	control->pos.xy.x = pos.xyz.x;
	control->pos.xy.y = pos.xyz.y;
	control->sprite.size = hw;
	control->type = SWIFT_CONTROL_CLIPBOX;
	control->control_draw = &swift_draw_clipbox;
	control->control_update_pos = &swift_handle_control_move;
	control->control_unload = &swift_unload_base2;
	swift_widget_add(parent, control);

	control->sprite.pos.xyz.x = control->pos.xy.x + parent->sprite.pos.xyz.x;
	control->sprite.pos.xyz.y = control->pos.xy.y + parent->sprite.pos.xyz.y;
	control->sprite.pos.xyz.z = pos.xyz.z;
}

void swift_update_clipbox(swift_widget_t *control, swift_vec3f_t pos,
	swift_vec2f_t hw)
{
	control->pos.xy.x = pos.xyz.x;
	control->pos.xy.y = pos.xyz.y;
	control->sprite.size = hw;
	control->sprite.pos.xyz.x = control->pos.xy.x +
		control->parent->sprite.pos.xyz.x;
	control->sprite.pos.xyz.y = control->pos.xy.y +
		control->parent->sprite.pos.xyz.y;
	control->sprite.pos.xyz.z = pos.xyz.z;
}
