#include <swift/gui.h>
#include <swift/data.h>
#include <swift/window.h>

void swift_unload_base(swift_widgets_t *wgts, swift_widget_t *control)
{
	swift_unload_base2(wgts, control);
	swift_remove_texture(control->sprite.tex);
}

void swift_unload_base2(swift_widgets_t *wgts, swift_widget_t *control)
{
	control->unload(wgts, control);

	if (control->control)
		SWIFT_FREE(control->control);

	swift_term_list(&control->shown);
	swift_term_list(&control->hidden);
	swift_term_list(&control->snode);
	swift_term_list(&control->hnode);
}

void swift_handle_control_move(swift_widgets_t *wgts, swift_widget_t *control)
{
	control->sprite.pos.xyz.x = control->pos.xy.x +
		control->parent->sprite.pos.xyz.x;
	control->sprite.pos.xyz.y = control->pos.xy.y +
		control->parent->sprite.pos.xyz.y;

	control->update_pos(wgts, control);
}

void swift_draw_base(swift_widgets_t *wgts, swift_widget_t *control)
{
	if (!wgts || !wgts->window || !control)
		return;

	swift_render(wgts->window, &control->sprite);
}
