#include <swift/gui.h>
#include <swift/window.h>

static void swift_handle_frame_click(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	if (control->action.can_use_event)
		control->mouse_down(wgts, control, button, pressed);

	if (control->action.window_moveable && button == SWIFT_MOUSE_BUTTON_LEFT)
			control->parent->action.moving = false;
}

void swift_create_frame(swift_widget_t *control, swift_widget_t *parent,
	swift_vec3f_t pos, swift_vec2f_t hw, bool window_moveable, bool visible)
{
	swift_init_widget(control);
	control->pos.xy.x = pos.xyz.x;
	control->pos.xy.y = pos.xyz.y;
	control->sprite.size = hw;
	control->type = SWIFT_CONTROL_FRAME;
	control->control_mouse_down = &swift_handle_frame_click;
	control->control_update_pos = &swift_handle_control_move;
	control->control_unload = &swift_unload_base2;

	if (window_moveable)
		control->action.window_moveable = true;

	if (visible)
		swift_widget_add(parent, control);
	else
		swift_widget_add_hidden(parent, control);;

	control->sprite.pos.xyz.x = control->pos.xy.x + parent->sprite.pos.xyz.x;
	control->sprite.pos.xyz.y = control->pos.xy.y + parent->sprite.pos.xyz.y;
	control->sprite.pos.xyz.z = pos.xyz.z;
}
