#ifndef SWIFT_SYS_CONTROL_INPUT_H
#define SWIFT_SYS_CONTROL_INPUT_H

#include <swift/window.h>
#include <swift/stdlib.h>

typedef struct swift_intern_gui_cb_t swift_intern_gui_cb_t;

struct swift_intern_gui_cb_t {
	swift_gui_win_pos_fn_t win_pos;
	swift_gui_win_resize_fn_t win_resize;
	swift_gui_win_close_fn_t win_close;
	swift_gui_win_refresh_fn_t win_refresh;
	swift_gui_win_focus_fn_t win_focus;
	swift_gui_iconify_fn_t iconify;
	swift_gui_buf_resize_fn_t buffer_resize;
	swift_gui_mouse_btn_fn_t mouse_button;
	swift_gui_cur_pos_fn_t cursor_pos;
	swift_gui_cur_enter_fn_t cursor_enter;
	swift_gui_scroll_fn_t scroll;
	swift_gui_key_fn_t keys;
	swift_gui_char_fn_t chars;
	swift_gui_mods_fn_t mods;
	swift_gui_drop_fn_t drops;
};

bool swift_create_gui_callbacks(swift_widgets_t *wgts);
void swift_destroy_gui_callbacks(swift_widgets_t *wgts);
void swift_gui_char_callback(swift_window_t *window, unsigned int key);
void swift_gui_key_callback(swift_window_t *window, int key, int scancode,
	int action, int mods);
void swift_gui_mouse_pos_callback(swift_window_t *window, double x, double y);
void swift_gui_mouse_press_callback(swift_window_t *window, int button,
	int pressed, int mods);
void swift_gui_mouse_wheel_callback(swift_window_t *window, double x, double y);
void swift_gui_window_close(swift_window_t *window);
void swift_gui_mods_callback(swift_window_t *window, unsigned int key,
	int mods);
void swift_gui_window_pos_callback(swift_window_t *window, int x, int y);
void swift_gui_window_resize_callback(swift_window_t *window, int width,
	int height);
void swift_gui_window_refresh_callback(swift_window_t *window);
void swift_gui_window_focus_callback(swift_window_t *window, int focused);
void swift_gui_iconify_callback(swift_window_t *window, int iconified);
void swift_gui_buffer_resize_callback(swift_window_t *window, int width,
	int height);
void swift_gui_cursor_entered_callback(swift_window_t *window, int entered);
void swift_gui_drops_callback(swift_window_t *window, int count,
	const char **paths);
#endif /*SWIFT_SYS_CONTROL_INPUT_H*/
