#include <swift/gui.h>
#include <swift/io.h>
#include <swift/window.h>

static void swift_handle_hscrollbar_magic(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	swift_scrollbar_t *scrl = control->control;

	float temppos = (wgts->new_mouse_pos.xy.x - control->sprite.pos.xyz.x -
		scrl->btn1.sprite.size.wh.w - (scrl->bar.sprite.size.wh.w / 2));
	float tempsize = ( control->sprite.size.wh.w -
		(scrl->btn1.sprite.size.wh.w * 2) - (scrl->bar.sprite.size.wh.w));

	if (temppos < 0)
		temppos = 0;

	if (temppos > tempsize)
		temppos = tempsize;

	scrl->bar.parent->value = (temppos / tempsize * scrl->bar.value);

	if (scrl->bar.parent->value > scrl->bar.value)
		scrl->bar.parent->value = scrl->bar.value;

	scrl->bar.pos.xy.x = (scrl->btn1.pos.xy.x +
		scrl->btn1.sprite.size.wh.w) + (scrl->bar.parent->value *
			(control->sprite.size.wh.w - (scrl->btn1.sprite.size.wh.w * 2) -
				scrl->bar.sprite.size.wh.w - 1) / scrl->bar.value);

	if (scrl->bar.parent->value == scrl->bar.value)
		scrl->bar.pos.xy.x += 1;

	scrl->bar.sprite.pos.xyz.x = scrl->bar.pos.xy.x +
		scrl->bar.parent->sprite.pos.xyz.x;

	scrl->btn1.mouse_down(wgts, scrl->btn1.parent, 0, 1);
}

static void swift_handle_harrow_click_magic(swift_widgets_t *wgts,
	swift_widget_t *control, bool add)
{
	swift_scrollbar_t *scrl = control->control;
	size_t i = 0;

	if (swift_widget_has_mouse_over(wgts, control)) {
		if (control->action.clicked)
			control->sprite.tex_pos.xywh.x = control->sprite.tex_pos.xywh.w;
	}

	if (add) {
		if (control->parent->value + 1 <= scrl->bar.value)
			control->parent->value++;
	}
	else {
		i = 1;

		if (control->parent->value > 0)
			control->parent->value--;
	}

	scrl->bar.pos.xy.x = (scrl->btn1.pos.xy.x + scrl->btn1.sprite.size.wh.w) +
		(control->parent->value *(control->parent->sprite.size.wh.w -
			(scrl->btn2.pos.xy.y + (scrl->btn2.sprite.size.wh.w * 2) +
					scrl->bar.sprite.size.wh.w - i)) / scrl->bar.value);

	scrl->bar.sprite.pos.xyz.x = scrl->bar.pos.xy.x +
		control->parent->sprite.pos.xyz.x;
}

static void swift_handle_harrow_over_magic(swift_widgets_t *wgts,
	swift_widget_t *control, bool left)
{
	swift_scrollbar_t *scrl = control->control;

	if (control->action.mouse_over)
		control->sprite.tex_pos.xywh.x = 2 * control->sprite.tex_pos.xywh.w;

	if (scrl->bar.action.moving) {
		control->parent->value = left ? 0 : scrl->bar.value;

		scrl->bar.pos.xy.x = (scrl->btn1.pos.xy.x +
			scrl->btn1.sprite.size.wh.w) + (control->parent->value *
				(control->parent->sprite.size.wh.w -
					(scrl->btn1.sprite.size.wh.w * 2) -
						scrl->bar.sprite.size.wh.w) / scrl->bar.value);

		scrl->bar.sprite.pos.xyz.x = scrl->bar.pos.xy.x +
			control->parent->sprite.pos.xyz.x;

		scrl->btn1.mouse_down(wgts, control->parent, 0, 1);
	}
}

static void swift_handle_vscrollbar_magic(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	swift_scrollbar_t *scrl = control->control;
	float temppos = (wgts->new_mouse_pos.xy.y - control->sprite.pos.xyz.y -
		scrl->btn1.sprite.size.wh.h - (scrl->bar.sprite.size.wh.h / 2));
	float tempsize = ( control->sprite.size.wh.h -
		(scrl->btn1.sprite.size.wh.h * 2) - (scrl->bar.sprite.size.wh.h));

	if (temppos < 0)
		temppos = 0;

	if (temppos > tempsize)
		temppos = tempsize;

	scrl->bar.parent->value = (temppos / tempsize * scrl->bar.value);

	if (scrl->bar.parent->value > scrl->bar.value)
		scrl->bar.parent->value = scrl->bar.value;

	scrl->bar.pos.xy.y = (scrl->btn1.pos.xy.y +
		scrl->btn1.sprite.size.wh.h) + (scrl->bar.parent->value *
			(control->sprite.size.wh.h - (scrl->btn1.sprite.size.wh.h * 2) -
				scrl->bar.sprite.size.wh.h - 1) / scrl->bar.value);

	if (scrl->bar.parent->value == scrl->bar.value)
		scrl->bar.pos.xy.y += 1;

	scrl->bar.sprite.pos.xyz.y = scrl->bar.pos.xy.y +
		scrl->bar.parent->sprite.pos.xyz.y;

	scrl->btn1.mouse_down(wgts, scrl->bar.parent, 0, 1);
}

static void swift_handle_varrow_click_magic(swift_widgets_t *wgts,
	swift_widget_t *control, bool add)
{
	swift_scrollbar_t *scrl = control->control;
	size_t i = 0;

	if (swift_widget_has_mouse_over(wgts, control)) {
		if (control->action.clicked)
			control->sprite.tex_pos.xywh.x = control->sprite.size.wh.w;
	}

	if (scrl->bar.action.moving)
		scrl->bar.action.moving = false;

	if (add) {
		if (control->parent->value + 1 <= scrl->bar.value)
			control->parent->value++;
	}
	else {
		i = 1;

		if (control->parent->value > 0)
			control->parent->value--;
	}

	scrl->bar.pos.xy.y = (scrl->btn1.pos.xy.y + scrl->btn1.sprite.size.wh.h) +
		(control->parent->value *(control->parent->sprite.size.wh.h -
			(scrl->btn1.sprite.size.wh.h * 2) - scrl->bar.sprite.size.wh.h -
				i) / scrl->bar.value);

	scrl->bar.sprite.pos.xyz.y = scrl->bar.pos.xy.y +
		control->parent->sprite.pos.xyz.y;
}

static void swift_handle_varrow_over_magic(swift_widgets_t *wgts,
	swift_widget_t *control, bool top)
{
	swift_scrollbar_t *scrl = control->control;

	if (control->action.mouse_over)
		control->sprite.tex_pos.xywh.x = 2 * control->sprite.size.wh.w;

	if (scrl->bar.action.moving) {
		control->parent->value = top ? 0 : scrl->bar.value;

		scrl->bar.pos.xy.y = (scrl->btn1.pos.xy.y + scrl->btn1.sprite.size.wh.h) +
		(control->parent->value *(control->parent->sprite.size.wh.h -
			(scrl->btn1.sprite.size.wh.h * 2) - scrl->bar.sprite.size.wh.h) /
				scrl->bar.value);

		scrl->bar.sprite.pos.xyz.y = scrl->bar.pos.xy.y +
			control->parent->sprite.pos.xyz.y;

		scrl->btn1.mouse_down(wgts, control->parent, 0, 1);
	}
}

static void swift_handle_event_exit(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	control->sprite.tex_pos.xywh.x = 0;

	control->mouse_exit(wgts, control);
}

static void swift_handle_scrollbar_release(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	swift_scrollbar_t *scrl = control->control;

	if (scrl->bar.action.moving)
		scrl->bar.action.moving = false;
}

static void swift_handle_bar_release(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	if (control->action.moving)
		control->action.moving = false;

	if (swift_widget_has_mouse_over(wgts, control))
		control->sprite.tex_pos.xywh.x = 2 * control->sprite.tex_pos.xywh.w;
}

static void swift_handle_bar_click(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	if (!control->action.moving)
		control->action.moving = true;

	if (swift_widget_has_mouse_over(wgts, control)) {
		if (control->action.clicked)
			control->sprite.tex_pos.xywh.x = control->sprite.tex_pos.xywh.w;
	}
}

static void swift_handle_button_release(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	swift_scrollbar_t *scrl = control->control;

	if (scrl->bar.action.moving)
		scrl->bar.action.moving = false;

	if (swift_widget_has_mouse_over(wgts, control))
		control->sprite.tex_pos.xywh.x = 2 * control->sprite.tex_pos.xywh.w;

	control->mouse_up(wgts, control->parent, button, pressed);
}

static void swift_handle_bar_over(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	if (control->action.mouse_over)
		control->sprite.tex_pos.xywh.x = 2 * control->sprite.tex_pos.xywh.w;
}

static void swift_handle_harrowleft_click(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	swift_handle_harrow_click_magic(wgts, control, false);
	control->mouse_down(wgts, control->parent, button, pressed);
}


static void swift_handle_harrowright_click(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	swift_handle_harrow_click_magic(wgts, control, true);
	control->mouse_down(wgts, control->parent, button, pressed);
}

static void swift_handle_harrowleft_over(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	swift_handle_harrow_over_magic(wgts, control, true);
}

static void swift_handle_harrowright_over(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	swift_handle_harrow_over_magic(wgts, control, false);
}

static void swift_handle_hscrollbar_click(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	if (button == 0)
		swift_handle_hscrollbar_magic(wgts, control);
}

static void swift_handle_hbar_slide(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	swift_scrollbar_t *scrl = control->control;

	if (scrl->bar.action.moving)
		swift_handle_hscrollbar_magic(wgts, control);
}

static void swift_handle_varrowtop_over(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	swift_handle_varrow_over_magic(wgts, control, true);
}

static void swift_handle_varrowbottom_over(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	swift_handle_varrow_over_magic(wgts, control, false);
}

static void swift_handle_vbar_slide(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	swift_scrollbar_t *scrl = control->control;

	if (scrl->bar.action.moving)
		swift_handle_vscrollbar_magic(wgts, control);
}

static void swift_handle_vscrollbar_click(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	if (button == 0)
		swift_handle_vscrollbar_magic(wgts, control);
}

static void swift_handle_varrowtop_click(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	swift_handle_varrow_click_magic(wgts, control, false);
	control->mouse_down(wgts, control->parent, button, pressed);
}

static void swift_handle_varrowbottom_click(swift_widgets_t *wgts,
	swift_widget_t *control, int button, int pressed)
{
	swift_handle_varrow_click_magic(wgts, control, true);
	control->mouse_down(wgts, control->parent, button, pressed);
}

void swift_unload_scrollbar_items(swift_widgets_t *wgts,
	swift_widget_t *control)
{
	control->control = NULL;
	swift_unload_base2(wgts, control);
	swift_remove_texture(control->sprite.tex);
}

void swift_create_hscrollbar(swift_widget_t *control, swift_widget_t *parent,
	swift_vec3f_t pos, swift_vec2f_t hw, swift_vec2f_t button_hw,
		size_t value, size_t max_value, swift_str_t *bkgd, swift_str_t *btnl,
			swift_str_t *btnr, swift_str_t *bar, bool visible)
{
	swift_scrollbar_t *scrl = calloc(1, sizeof(swift_scrollbar_t));

	if (!scrl) {
		fprintf(stderr, "POINTER_NULL, scrl in swift_create_hscrollbar.\n");
		return;
	}

	swift_init_widget(control);
	swift_init_widget(&scrl->bar);
	swift_init_widget(&scrl->btn1);
	swift_init_widget(&scrl->btn2);

	control->sprite.tex = swift_add_texture(bkgd->data);
	control->sprite.shader = swift_get_shader("swift_basic_shader");
	control->pos.xy.x = pos.xyz.x;
	control->pos.xy.y = pos.xyz.y;
	control->sprite.size = hw;
	control->sprite.tex_pos.xywh.w = hw.wh.w;
	control->sprite.tex_pos.xywh.h = hw.wh.h;
	control->type = SWIFT_CONTROL_HSCROLL_BAR;
	control->control_draw = &swift_draw_base;
	control->control_mouse_down = &swift_handle_hscrollbar_click;
	control->control_update_pos = &swift_handle_control_move;
	control->control_mouse_over = &swift_handle_hbar_slide;
	control->control_mouse_up = &swift_handle_scrollbar_release;
	control->control_unload = &swift_unload_base;
	control->value = value;

	scrl->btn1.sprite.tex = swift_add_texture(btnl->data);
	scrl->btn1.sprite.shader = swift_get_shader("swift_basic_shader");
	scrl->btn1.sprite.size = button_hw;
	scrl->btn1.sprite.tex_pos.xywh.w = button_hw.wh.w;
	scrl->btn1.sprite.tex_pos.xywh.h = button_hw.wh.h;
	scrl->btn1.type = SWIFT_CONTROL_BUTTON;
	scrl->btn1.control_mouse_down = &swift_handle_harrowleft_click;
	scrl->btn1.control_update_pos = &swift_handle_control_move;
	scrl->btn1.control_mouse_over = &swift_handle_harrowleft_over;
	scrl->btn1.control_mouse_up = &swift_handle_button_release;
	scrl->btn1.control_mouse_exit = &swift_handle_event_exit;
	scrl->btn1.control_draw = &swift_draw_base;
	scrl->btn1.control_unload = &swift_unload_scrollbar_items;

	scrl->btn2.sprite.tex = swift_add_texture(btnr->data);
	scrl->btn2.sprite.shader = swift_get_shader("swift_basic_shader");
	scrl->btn2.sprite.size = button_hw;
	scrl->btn2.sprite.tex_pos.xywh.w = button_hw.wh.w;
	scrl->btn2.sprite.tex_pos.xywh.h = button_hw.wh.h;
	scrl->btn2.pos.xy.x = hw.wh.w - scrl->btn2.sprite.size.wh.w;
	scrl->btn2.type = SWIFT_CONTROL_BUTTON;
	scrl->btn2.control_mouse_down = &swift_handle_harrowright_click;
	scrl->btn2.control_update_pos = &swift_handle_control_move;
	scrl->btn2.control_mouse_over = &swift_handle_harrowright_over;
	scrl->btn2.control_mouse_up = &swift_handle_button_release;
	scrl->btn2.control_mouse_exit = &swift_handle_event_exit;
	scrl->btn2.control_draw = &swift_draw_base;
	scrl->btn2.control_unload = &swift_unload_scrollbar_items;

	scrl->bar.sprite.tex = swift_add_texture(bar->data);
	scrl->bar.sprite.shader = swift_get_shader("swift_basic_shader");
	scrl->bar.sprite.tex_pos.xywh.h = scrl->bar.sprite.tex->size.wh.h;
	scrl->bar.sprite.tex_pos.xywh.w = scrl->bar.sprite.tex->size.wh.w / 3;
	scrl->bar.type = SWIFT_CONTROL_BUTTON;
	scrl->bar.sprite.size.wh.w = (hw.wh.w + scrl->btn2.sprite.size.wh.w  +
		scrl->btn1.sprite.size.wh.w) / max_value + 1;
	scrl->bar.sprite.size.wh.h = hw.wh.h;

	if (scrl->bar.sprite.size.wh.w < 2)
		scrl->bar.sprite.size.wh.w = 2;

	if (scrl->bar.sprite.size.wh.w > hw.wh.w - (scrl->btn2.sprite.size.wh.w  +
		scrl->btn1.sprite.size.wh.w))
		scrl->bar.sprite.size.wh.w = hw.wh.w - (scrl->btn2.sprite.size.wh.w  +
			scrl->btn1.sprite.size.wh.w) - max_value;

	scrl->bar.pos.xy.x = (scrl->btn1.pos.xy.x + scrl->btn1.sprite.size.wh.w) +
		(value *(hw.wh.w - (scrl->btn1.sprite.size.wh.w) - 1 ) / max_value);

	scrl->bar.value = max_value;

	if (scrl->bar.pos.xy.x < scrl->btn1.pos.xy.x)
		scrl->bar.pos.xy.x = scrl->btn1.pos.xy.x +
			scrl->btn1.sprite.size.wh.w;

	if (scrl->bar.pos.xy.x > scrl->btn2.pos.xy.x)
		scrl->bar.pos.xy.x = scrl->btn2.pos.xy.x;

	scrl->bar.control_update_pos = &swift_handle_control_move;
	scrl->bar.control_mouse_down = &swift_handle_bar_click;
	scrl->bar.control_mouse_up = &swift_handle_bar_release;
	scrl->bar.control_mouse_over = &swift_handle_bar_over;
	scrl->bar.control_mouse_exit = &swift_handle_event_exit;
	scrl->bar.control_draw = &swift_draw_base;
	scrl->bar.control_unload = &swift_unload_scrollbar_items;
	control->control = scrl;
	scrl->bar.control = scrl;
	scrl->btn1.control = scrl;
	scrl->btn2.control = scrl;

	if (visible)
		swift_widget_add(parent, control);
	else
		swift_widget_add_hidden(parent, control);

	swift_widget_add(control, &scrl->btn1);
	swift_widget_add(control, &scrl->btn2);
	swift_widget_add(control, &scrl->bar);

	control->sprite.pos.xyz.x = control->pos.xy.x + parent->sprite.pos.xyz.x;
	control->sprite.pos.xyz.y = control->pos.xy.y + parent->sprite.pos.xyz.y;
	control->sprite.pos.xyz.z = pos.xyz.z;

	scrl->btn1.sprite.pos.xyz.x = scrl->btn1.pos.xy.x +
		control->sprite.pos.xyz.x;
	scrl->btn1.sprite.pos.xyz.y = scrl->btn1.pos.xy.y +
		control->sprite.pos.xyz.y;
	scrl->btn1.sprite.pos.xyz.z = pos.xyz.z;

	scrl->btn2.sprite.pos.xyz.x = scrl->btn2.pos.xy.x +
		control->sprite.pos.xyz.x;
	scrl->btn2.sprite.pos.xyz.y = scrl->btn2.pos.xy.y +
		control->sprite.pos.xyz.y;
	scrl->btn2.sprite.pos.xyz.z = pos.xyz.z;

	scrl->bar.sprite.pos.xyz.x = scrl->bar.pos.xy.x +
		control->sprite.pos.xyz.x;
	scrl->bar.sprite.pos.xyz.y = scrl->bar.pos.xy.y +
		control->sprite.pos.xyz.y;
	scrl->bar.sprite.pos.xyz.z = pos.xyz.z;

	swift_del_str(bkgd);
	swift_del_str(btnl);
	swift_del_str(btnr);
	swift_del_str(bar);
}

void swift_set_scrollbar_buttons_mouse_down(swift_widget_t *control,
	swift_control_mouse_down callback)
{
	swift_scrollbar_t *scrl = control->control;

	scrl->btn1.mouse_down = callback;
	scrl->btn2.mouse_down = callback;
}

void swift_hscrollbar_value_reset(swift_widget_t *control, size_t value,
	size_t maxvalue)
{
	swift_scrollbar_t *scrl = control->control;

	control->value = value;
	scrl->bar.value = maxvalue;
	scrl->bar.sprite.size.wh.w = (control->sprite.size.wh.w +
		scrl->btn2.sprite.size.wh.w  + scrl->btn1.sprite.size.wh.w) /
			maxvalue + 1;

	if (scrl->bar.sprite.size.wh.w < 2)
		scrl->bar.sprite.size.wh.w = 2;

	if (scrl->bar.sprite.size.wh.w > control->sprite.size.wh.w -
		(scrl->btn2.sprite.size.wh.w  + scrl->btn1.sprite.size.wh.w))
		scrl->bar.sprite.size.wh.w = control->sprite.size.wh.w -
			(scrl->btn2.sprite.size.wh.w  + scrl->btn1.sprite.size.wh.w) -
				maxvalue;

	if (control->value > scrl->bar.value)
		control->value = scrl->bar.value;

	scrl->bar.pos.xy.x = (scrl->btn1.pos.xy.x + scrl->btn1.sprite.size.wh.w) +
		(control->value *(control->sprite.size.wh.w -
			(scrl->btn1.sprite.size.wh.w * 2) -
				scrl->bar.sprite.size.wh.w - 1) / scrl->bar.value);

	if (control->value == scrl->bar.value)
		scrl->bar.pos.xy.x += 1;

	scrl->bar.sprite.pos.xyz.x = scrl->bar.pos.xy.x +
		scrl->bar.parent->sprite.pos.xyz.x;
	scrl->bar.sprite.pos.xyz.y = scrl->bar.pos.xy.y +
		scrl->bar.parent->sprite.pos.xyz.y;
}

void swift_create_vscrollbar(swift_widget_t *control, swift_widget_t *parent,
	swift_vec3f_t pos, swift_vec2f_t hw, swift_vec2f_t button_hw,
		size_t value, size_t max_value, swift_str_t *bkgd, swift_str_t *btnt,
			swift_str_t *btnb, swift_str_t *bar, bool visible)
{
	swift_scrollbar_t *scrl = calloc(1, sizeof(swift_scrollbar_t));

	if (!scrl) {
		fprintf(stderr, "POINTER_NULL, scrl in swift_create_vscrollbar.\n");
		return;
	}

	swift_init_widget(control);
	swift_init_widget(&scrl->bar);
	swift_init_widget(&scrl->btn1);
	swift_init_widget(&scrl->btn2);

	control->sprite.tex = swift_add_texture(bkgd->data);
	control->sprite.shader = swift_get_shader("swift_basic_shader");
	control->pos.xy.x = pos.xyz.x;
	control->pos.xy.y = pos.xyz.y;
	control->sprite.size = hw;
	control->sprite.tex_pos.xywh.w = hw.wh.w;
	control->sprite.tex_pos.xywh.h = hw.wh.h;
	control->type = SWIFT_CONTROL_VSCROLL_BAR;
	control->control_draw = &swift_draw_base;
	control->control_mouse_down = &swift_handle_vscrollbar_click;
	control->control_update_pos = &swift_handle_control_move;
	control->control_mouse_over = &swift_handle_vbar_slide;
	control->control_mouse_up = &swift_handle_scrollbar_release;
	control->control_unload = &swift_unload_base;
	control->value = value;

	scrl->btn1.sprite.tex = swift_add_texture(btnt->data);
	scrl->btn1.sprite.shader = swift_get_shader("swift_basic_shader");
	scrl->btn1.sprite.tex_pos.xywh.h = scrl->btn1.sprite.tex->size.wh.h;
	scrl->btn1.sprite.tex_pos.xywh.w = scrl->btn1.sprite.tex->size.wh.w / 3;
	scrl->btn1.sprite.size.wh.h = scrl->btn1.sprite.tex->size.wh.h;
	scrl->btn1.sprite.size.wh.w = scrl->btn1.sprite.tex->size.wh.w / 3;
	scrl->btn1.type = SWIFT_CONTROL_BUTTON;
	scrl->btn1.control_draw = &swift_draw_base;
	scrl->btn1.control_mouse_down = &swift_handle_varrowtop_click;
	scrl->btn1.control_update_pos = &swift_handle_control_move;
	scrl->btn1.control_mouse_over = &swift_handle_varrowtop_over;
	scrl->btn1.control_mouse_up = &swift_handle_button_release;
	scrl->btn1.control_mouse_exit = &swift_handle_event_exit;
	scrl->btn1.control_unload = &swift_unload_scrollbar_items;

	scrl->btn2.sprite.tex = swift_add_texture(btnb->data);
	scrl->btn2.sprite.shader = swift_get_shader("swift_basic_shader");
	scrl->btn2.sprite.size.wh.h = scrl->btn2.sprite.tex->size.wh.h;
	scrl->btn2.sprite.size.wh.w = scrl->btn2.sprite.tex->size.wh.w / 3;
	scrl->btn2.pos.xy.y = hw.wh.h - scrl->btn2.sprite.size.wh.h;
	scrl->btn2.sprite.tex_pos.xywh.h = scrl->btn2.sprite.tex->size.wh.h;
	scrl->btn2.sprite.tex_pos.xywh.w = scrl->btn2.sprite.tex->size.wh.w / 3;
	scrl->btn2.type = SWIFT_CONTROL_BUTTON;
	scrl->btn2.control_draw = &swift_draw_base;
	scrl->btn2.control_mouse_down = &swift_handle_varrowbottom_click;
	scrl->btn2.control_update_pos = &swift_handle_control_move;
	scrl->btn2.control_mouse_over = &swift_handle_varrowbottom_over;
	scrl->btn2.control_mouse_up = &swift_handle_button_release;
	scrl->btn2.control_mouse_exit = &swift_handle_event_exit;
	scrl->btn2.control_unload = &swift_unload_scrollbar_items;

	scrl->bar.sprite.tex = swift_add_texture(bar->data);
	scrl->bar.sprite.shader = swift_get_shader("swift_basic_shader");
	scrl->bar.type = SWIFT_CONTROL_BUTTON;
	scrl->bar.sprite.size.wh.h = scrl->bar.sprite.tex->size.wh.h;
	scrl->bar.sprite.size.wh.w = scrl->bar.sprite.tex->size.wh.w / 3;
	scrl->bar.sprite.tex_pos.xywh.h = scrl->bar.sprite.tex->size.wh.h;
	scrl->bar.sprite.tex_pos.xywh.w = scrl->bar.sprite.tex->size.wh.w / 3;

	scrl->bar.sprite.size.wh.h = (scrl->btn1.sprite.size.wh.h  +
		scrl->btn2.sprite.size.wh.h - scrl->bar.sprite.tex->size.wh.h) /
			max_value;

	if (scrl->bar.sprite.size.wh.h < 2)
		scrl->bar.sprite.size.wh.h = 2;

	if (scrl->bar.sprite.size.wh.h > hw.wh.h - (scrl->btn2.sprite.size.wh.h  +
		scrl->btn1.sprite.size.wh.h))
		scrl->bar.sprite.size.wh.h = hw.wh.h - (scrl->btn2.sprite.size.wh.h  +
				scrl->btn1.sprite.size.wh.h) - max_value;

	scrl->bar.pos.xy.y = (scrl->btn1.pos.xy.y + scrl->btn1.sprite.size.wh.h) +
			(value *(hw.wh.h - (scrl->btn1.sprite.size.wh.h * 2) - 1 ) /
				max_value);

	scrl->bar.value = max_value;
	scrl->bar.pos.xy.x = 0;

	if (scrl->bar.pos.xy.y < scrl->btn1.pos.xy.y)
		scrl->bar.pos.xy.y = scrl->btn1.pos.xy.y;

	if (scrl->bar.pos.xy.y > scrl->btn2.pos.xy.y)
		scrl->bar.pos.xy.y = scrl->btn2.pos.xy.y;

	scrl->bar.control_update_pos = &swift_handle_control_move;
	scrl->bar.control_mouse_down = &swift_handle_bar_click;
	scrl->bar.control_mouse_up = &swift_handle_bar_release;
	scrl->bar.control_mouse_exit = &swift_handle_event_exit;
	scrl->bar.control_mouse_over = &swift_handle_bar_over;
	scrl->bar.control_draw = &swift_draw_base;
	scrl->bar.control_unload = &swift_unload_scrollbar_items;

	control->control = scrl;
	scrl->bar.control = scrl;
	scrl->btn1.control = scrl;
	scrl->btn2.control = scrl;

	if (visible)
		swift_widget_add(parent, control);
	else
		swift_widget_add_hidden(parent, control);

	swift_widget_add(control, &scrl->btn1);
	swift_widget_add(control, &scrl->btn2);
	swift_widget_add(control, &scrl->bar);

	control->sprite.pos.xyz.x = control->pos.xy.x + parent->sprite.pos.xyz.x;
	control->sprite.pos.xyz.y = control->pos.xy.y + parent->sprite.pos.xyz.y;
	control->sprite.pos.xyz.z = pos.xyz.z;

	scrl->btn1.sprite.pos.xyz.x = scrl->btn1.pos.xy.x +
		control->sprite.pos.xyz.x;
	scrl->btn1.sprite.pos.xyz.y = scrl->btn1.pos.xy.y +
		control->sprite.pos.xyz.y;
	scrl->btn1.sprite.pos.xyz.z = pos.xyz.z;

	scrl->btn2.sprite.pos.xyz.x = scrl->btn2.pos.xy.x +
		control->sprite.pos.xyz.x;
	scrl->btn2.sprite.pos.xyz.y = scrl->btn2.pos.xy.y +
		control->sprite.pos.xyz.y;
	scrl->btn2.sprite.pos.xyz.z = pos.xyz.z;

	scrl->bar.sprite.pos.xyz.x = scrl->bar.pos.xy.x +
		control->sprite.pos.xyz.x;
	scrl->bar.sprite.pos.xyz.y = scrl->bar.pos.xy.y +
		control->sprite.pos.xyz.y;
	scrl->bar.sprite.pos.xyz.z = pos.xyz.z;

	swift_del_str(bkgd);
	swift_del_str(btnt);
	swift_del_str(btnb);
	swift_del_str(bar);
}

void swift_vscrollbar_value_reset(swift_widget_t *control, size_t value,
	size_t maxvalue)
{
	swift_scrollbar_t *scrl = control->control;

	control->value = value;
	scrl->bar.value = maxvalue;

	scrl->bar.sprite.size.wh.h = (control->sprite.size.wh.h +
		scrl->btn1.sprite.size.wh.h + scrl->btn2.sprite.size.wh.h) /
			maxvalue + 1;

	if (scrl->bar.sprite.size.wh.h < 2)
		scrl->bar.sprite.size.wh.h = 2;

	if (scrl->bar.sprite.size.wh.h > control->sprite.size.wh.h -
		(scrl->btn1.sprite.size.wh.h  + scrl->btn2.sprite.size.wh.h))
		scrl->bar.sprite.size.wh.h = control->sprite.size.wh.h -
			(scrl->btn1.sprite.size.wh.h  + scrl->btn2.sprite.size.wh.h) -
				maxvalue;

	if (control->value > scrl->bar.value)
		control->value = scrl->bar.value;

	scrl->bar.pos.xy.y = (scrl->btn1.pos.xy.y + scrl->btn1.sprite.size.wh.h) +
		(control->value *(control->sprite.size.wh.h -
			(scrl->btn1.sprite.size.wh.h * 2) -
				scrl->bar.sprite.size.wh.h - 1) / scrl->bar.value);

	if (control->value == scrl->bar.value)
		scrl->bar.pos.xy.y += 1;

	scrl->bar.sprite.pos.xyz.x = scrl->bar.pos.xy.x +
		scrl->bar.parent->sprite.pos.xyz.x;
	scrl->bar.sprite.pos.xyz.y = scrl->bar.pos.xy.y +
		scrl->bar.parent->sprite.pos.xyz.y;
}
