#include <swift/gui.h>
#include <swift/io.h>
#include <swift/window.h>

void swift_gui_create_window(swift_widget_t *control, swift_widget_t *parent,
	swift_vec3f_t pos, swift_vec2f_t hw, swift_str_t *img_path, bool visible)
{
	swift_init_widget(control);
	control->pos.xy.x = pos.xyz.x;
	control->pos.xy.y = pos.xyz.y;
	control->sprite.size = hw;
	control->sprite.tex_pos.xywh.h = hw.wh.h;
	control->sprite.tex_pos.xywh.w = hw.wh.w;
	control->type = SWIFT_CONTROL_WINDOW;
	control->control_draw = &swift_draw_base;
	control->control_unload = &swift_unload_base;
	control->control_update_pos = &swift_handle_control_move;
	control->sprite.tex = swift_add_texture(img_path->data);
	control->sprite.shader = swift_get_shader("swift_basic_shader");
	control->action.can_focus = true;

	if (visible)
		swift_widget_add(parent, control);
	else
		swift_widget_add_hidden(parent, control);

	control->sprite.pos.xyz.x = control->pos.xy.x + parent->sprite.pos.xyz.x;
	control->sprite.pos.xyz.y = control->pos.xy.y + parent->sprite.pos.xyz.y;
	control->sprite.pos.xyz.z = pos.xyz.z;

	swift_del_str(img_path);
}
