#include <swift/maths.h>

swift_vec4u_t swift_vec4u_zero(void)
{
	return SWIFT_VEC4U(0);
}

swift_vec4u_t swift_vec4u_neg(swift_vec4u_t vec)
{
	return SWIFT_VEC4U(
		-vec.xywh.x,
		-vec.xywh.y,
		-vec.xywh.w,
		-vec.xywh.h,
	);
}

swift_vec4u_t swift_vec4u_add_scalar(swift_vec4u_t lhs, unsigned int rhs)
{
	return SWIFT_VEC4U(
		lhs.xywh.x + rhs,
		lhs.xywh.y + rhs,
		lhs.xywh.w + rhs,
		lhs.xywh.h + rhs,
	);
}

swift_vec4u_t swift_vec4u_sub_scalar(swift_vec4u_t lhs, unsigned int rhs)
{
	return SWIFT_VEC4U(
		lhs.xywh.x - rhs,
		lhs.xywh.y - rhs,
		lhs.xywh.w - rhs,
		lhs.xywh.h - rhs,
	);
}

swift_vec4u_t swift_vec4u_mul_scalar(swift_vec4u_t lhs, unsigned int rhs)
{
	return SWIFT_VEC4U(
		lhs.xywh.x * rhs,
		lhs.xywh.y * rhs,
		lhs.xywh.w * rhs,
		lhs.xywh.h * rhs,
	);
}

swift_vec4u_t swift_vec4u_div_scalar(swift_vec4u_t lhs, unsigned int rhs)
{
	return SWIFT_VEC4U(
		lhs.xywh.x / rhs,
		lhs.xywh.y / rhs,
		lhs.xywh.w / rhs,
		lhs.xywh.h / rhs,
	);
}

swift_vec4u_t swift_vec4u_add(swift_vec4u_t lhs, swift_vec4u_t rhs)
{
	return SWIFT_VEC4U(
		lhs.xywh.x + rhs.xywh.x,
		lhs.xywh.y + rhs.xywh.y,
		lhs.xywh.w + rhs.xywh.w,
		lhs.xywh.h + rhs.xywh.h,
	);
}

swift_vec4u_t swift_vec4u_sub(swift_vec4u_t lhs, swift_vec4u_t rhs)
{
	return SWIFT_VEC4U(
		lhs.xywh.x - rhs.xywh.x,
		lhs.xywh.y - rhs.xywh.y,
		lhs.xywh.w - rhs.xywh.w,
		lhs.xywh.h - rhs.xywh.h,
	);
}

unsigned int swift_vec4u_dot(swift_vec4u_t lhs, swift_vec4u_t rhs)
{
	unsigned int ret = 0;
	size_t i;

	for (i = 0; i < 4; ++i)
		ret += lhs.data[i] * rhs.data[i];

	return ret;
}

unsigned int swift_vec4u_norm(swift_vec4u_t vec)
{
	return sqrt(swift_vec4u_dot(vec, vec));
}

swift_vec4u_t swift_vec4u_normalise(swift_vec4u_t vec)
{
	return swift_vec4u_div_scalar(vec, swift_vec4u_norm(vec));
}
