#ifndef EPOLL_MONITOR_H
#define EPOLL_MONITOR_H

#include <swift/data.h>
#include <swift/net.h>

typedef struct sys_event_t sys_event_t;
typedef struct sys_monitor_t sys_monitor_t;
typedef struct sys_event_queue_t sys_event_queue_t;

typedef void (* sys_on_complete_func_t)(bool error, swift_sock_t *sock,
	sys_event_t *event);

struct sys_monitor_t {
	swift_htable_t *event_queues;
	int handle;
};

struct sys_event_queue_t {
	swift_sock_t *sock;
	swift_list_t in_events;
	swift_list_t out_events;
};

struct sys_event_t {
	swift_list_t node;
	sys_on_complete_func_t on_complete;
};

sys_event_queue_t *sys_get_event_queue(swift_monitor_t *monitor,
	swift_sock_t *sock);

#endif /* EPOLL_MONITOR_H */
