#ifndef EPOLL_SOCK_H
#define EPOLL_SOCK_H

#include <swift/net.h>

typedef struct sys_event_t sys_event_t;
typedef struct sys_accept_event_t sys_accept_event_t;
typedef struct sys_connect_event_t sys_connect_event_t;
typedef struct sys_recv_event_t sys_recv_event_t;
typedef struct sys_send_event_t sys_send_event_t;

struct sys_accept_event_t {
	sys_event_t event;
	swift_on_accept_fn_t on_accept;
	swift_sock_t *sock;
	void *user_data, *data;
	size_t size;
};

struct sys_connect_event_t {
	sys_event_t event;
	swift_on_connect_fn_t on_connect;
	swift_sock_t *sock;
	swift_addr_t *addr;
	void *user_data;
};

struct sys_recv_event_t {
	sys_event_t event;
	swift_on_recv_fn_t on_recv;
	swift_sock_t *sock;
	void *user_data, *data;
	size_t size;
};

struct sys_send_event_t {
	sys_event_t event;
	swift_on_send_fn_t on_send;
	swift_sock_t *sock;
	void *user_data;
	const void *data;
	size_t size;
};

#endif /* EPOLL_SOCK_H */
