#ifndef MSW_ADDR_H
#define MSW_ADDR_H

typedef struct sys_addr_ops_t sys_addr_ops_t;
typedef struct sys_addr_t sys_addr_t;

typedef void (* sys_term_addr_fn_t)(swift_addr_t *addr);
typedef struct sockaddr *(* sys_addr_sockaddr_fn_t)(swift_addr_t *addr);
typedef size_t (* sys_addr_sockaddr_size_fn_t)(swift_addr_t *addr);

struct sys_addr_ops_t {
	sys_term_addr_fn_t term_addr;
	sys_addr_sockaddr_fn_t addr_sockaddr;
	sys_addr_sockaddr_size_fn_t addr_sockaddr_size;
};

struct sys_addr_t {
	sys_addr_ops_t *ops;
};

struct sockaddr *sys_addr_sockaddr(swift_addr_t *addr);
size_t sys_addr_sockaddr_size(swift_addr_t *addr);

#endif /* MSW_ADDR_H */
