#ifndef MSW_SOCK_H
#define MSW_SOCK_H

#include <swift/net.h>

#define WIN32_MEAN_AND_LEAN
#include <winsock2.h>
#include <windows.h>
#include <ws2tcpip.h>
#include <mswsock.h>

typedef struct sys_sock_t sys_sock_t;
typedef struct sys_connect_event_t sys_connect_event_t;
typedef struct sys_accept_event_t sys_accept_event_t;
typedef struct sys_recv_event_t sys_recv_event_t;
typedef struct sys_send_event_t sys_send_event_t;

struct sys_sock_t {
	LPFN_CONNECTEX connect;
	LPFN_ACCEPTEX accept;
	LPFN_GETACCEPTEXSOCKADDRS get_accept_sockaddrs;
	SOCKET handle;
};

struct sys_connect_event_t {
	sys_event_t event;
	swift_on_connect_fn_t on_connect;
	void *user_data;
	swift_sock_t *sock;
	swift_addr_t *addr;
};

struct sys_accept_event_t {
	sys_event_t event;
	swift_on_accept_fn_t on_accept;
	void *user_data;
	swift_sock_t *sock, *peer;
	char *buffer;
	size_t local_addr_size, remote_addr_size;
};

struct sys_recv_event_t {
	sys_event_t event;
	swift_on_recv_fn_t on_recv;
	void *user_data;
	swift_sock_t *sock;
	WSABUF buf;
};

struct sys_send_event_t {
	sys_event_t event;
	swift_on_send_fn_t on_send;
	void *user_data;
	swift_sock_t *sock;
	WSABUF buf;
};

#endif /* MSW_SOCK_H */
