#include <swift/string.h>
#include <swift/thread.h>
#include <swift/event.h>
#include <swift/net.h>
#include <stdio.h>
#include "net.h"

bool swift_init_net(void)
{
	if (!swift_init_strings()) {
		fprintf(stderr, "error: swift string failed.\n");
		return false;
	}

	if (!swift_init_events())
		goto err_term_strings;

	if (!sys_init_net())
		goto err_term_events;

	return true;

err_term_events:
	fprintf(stderr, "error: Swift net failed.\n");
	swift_term_events();
err_term_strings:
	fprintf(stderr, "error: Swift threads failed.\n");
	swift_term_strings();
	return false;
}

void swift_term_net(void)
{
	sys_term_net();
	swift_term_events();
	swift_term_strings();
}
