#ifndef SYS_SOCK_H
#define SYS_SOCK_H

#include <swift/net.h>

bool sys_init_sock(swift_sock_t *sock, unsigned int addr_type,
	unsigned int proto_type);
bool sys_init_sock_from(swift_sock_t *sock, const void *data);
void sys_term_sock(swift_sock_t *sock);
size_t sys_sock_hash(const void *data);
bool sys_sock_eq(const void *lhs_, const void *rhs_);
size_t sys_peer_sock_hash(const void *data);
bool sys_peer_sock_eq(const void *lhs_, const void *rhs_);
unsigned int sys_sock_get_flags(swift_sock_t *sock);
bool sys_sock_set_flags(swift_sock_t *sock, unsigned int flags);
bool sys_sock_local_addr(swift_sock_t *sock, swift_addr_t *addr);
bool sys_sock_remote_addr(swift_sock_t *sock, swift_addr_t *addr);
bool sys_sock_connect(swift_sock_t *sock, swift_addr_t *addr);
bool sys_queue_connect(swift_sock_t *sock, swift_addr_t *addr,
	swift_on_connect_fn_t on_connect, void *user_data);
bool sys_sock_bind(swift_sock_t *sock, swift_addr_t *addr);
bool sys_sock_listen(swift_sock_t *sock, unsigned int back_log);
swift_sock_t *sys_sock_accept(swift_sock_t *sock);
bool sys_queue_accept(swift_sock_t *sock,
	swift_on_accept_fn_t on_accept, void *user_data);
size_t sys_sock_recv(swift_sock_t *sock, void *data, size_t size);
bool sys_queue_recv(swift_sock_t *sock, void *data, size_t size,
	swift_on_recv_fn_t on_recv, void *user_data);
size_t sys_sock_send(swift_sock_t *sock, const void *data, size_t size);
bool sys_queue_send(swift_sock_t *sock, const void *data, size_t size,
	swift_on_send_fn_t on_send, void *user_data);

#endif /* SYS_SOCK_H */
