#ifndef NATIVE_THREAD_H
#define NATIVE_THREAD_H

bool swift_init_threads(void);
void swift_term_threads(void);

void swift_thread_run(void *user_data);

bool native_init_threads(void);
void native_term_threads(void);

swift_thread_id_t native_get_current_thread_id(void);
void native_yield_thread(void);
void native_exit_thread(int status);

bool native_init_thread(swift_thread_t *thread, void *user_data,
	size_t stack_size, unsigned int flags);
bool native_init_current_thread(swift_thread_t *thread);
void native_term_thread(swift_thread_t *thread);

bool native_thread_setup(swift_thread_t *thread);
bool native_thread_wait(swift_thread_t *thread);
bool native_thread_cancel(swift_thread_t *thread);
bool native_thread_set_prio(swift_thread_t *thread, unsigned int prio);

#endif /* NATIVE_THREAD_H */
