#include <swift/time.h>

swift_time_t swift_add_time(swift_time_t lhs, swift_time_t rhs)
{
	lhs.s += rhs.s;
	lhs.ns += rhs.ns;

	lhs.s += lhs.ns / 1000000000;
	lhs.ns %= 1000000000;

	return lhs;
}

swift_time_t swift_sub_time(swift_time_t lhs, swift_time_t rhs)
{
	if (lhs.ns < rhs.ns) {
		--lhs.s;
		lhs.ns += 1000000000;
	}

	lhs.s -= rhs.s;
	lhs.ns -= rhs.ns;

	return lhs;
}

int swift_cmp_time(swift_time_t lhs, swift_time_t rhs)
{
	if (lhs.s != rhs.s)
		return (lhs.s < rhs.s) ? -1 : 1;

	if (lhs.ns != rhs.ns)
		return (lhs.ns < rhs.ns) ? -1 : 1;

	return 0;
}
