#include <swift/unicode.h>

size_t swift_enc_ascii(void *dst_, swift_uchar_t code)
{
	uint8_t *dst = (uint8_t *)dst_;

	if (code > 0x7F)
		code = SWIFT_ASCII_UNKNOWN;

	if (!dst)
		return sizeof(uint8_t);

	*dst = code;

	return sizeof(uint8_t);
}

swift_unicode_ret_t swift_dec_ascii(const void *src_, size_t src_size)
{
	uint8_t *src = (uint8_t *)src_;
	swift_uchar_t code;

	if (!src || !src_size)
		return SWIFT_UNICODE_RET(0, 0, true);

	code = (*src++ & 0x7F);

	return SWIFT_UNICODE_RET(sizeof(uint8_t), code, true);
}
