#ifndef SWIFT_SYS_CALLBACKS_H
#define SWIFT_SYS_CALLBACKS_H
#include <swift/window.h>
#include <GLFW/glfw3.h>

typedef struct swift_intern_cb_t swift_intern_cb_t;

struct swift_intern_cb_t {
	swift_win_pos_fn_t win_pos;
	swift_win_resize_fn_t win_resize;
	swift_win_close_fn_t win_close;
	swift_win_refresh_fn_t win_refresh;
	swift_win_focus_fn_t win_focus;
	swift_iconify_fn_t iconify;
	swift_buf_resize_fn_t buffer_resize;
	swift_mouse_btn_fn_t mouse_button;
	swift_cur_pos_fn_t cursor_pos;
	swift_cur_enter_fn_t cursor_enter;
	swift_scroll_fn_t scroll;
	swift_key_fn_t keys;
	swift_char_fn_t chars;
	swift_mods_fn_t mods;
	swift_drop_fn_t drops;
};

void swift_callback_char(GLFWwindow *screen, unsigned int key);
void swift_callback_mods(GLFWwindow *screen, unsigned int key, int mods);
void swift_callback_key(GLFWwindow *screen, int key, int scancode, int action,
	int mods);
void swift_callback_cursor_pos(GLFWwindow *screen, double x, double y);
void swift_callback_mouse_press(GLFWwindow *screen, int button, int pressed,
	int mods);
void swift_callback_scroll(GLFWwindow *screen, double x, double y);
void swift_callback_window_close(GLFWwindow *screen);
void swift_callback_window_pos(GLFWwindow *screen, int x, int y);
void swift_callback_window_resize(GLFWwindow *screen, int width, int height);
void swift_callback_window_refresh(GLFWwindow *screen);
void swift_callback_window_focus(GLFWwindow *screen, int focused);
void swift_callback_iconify(GLFWwindow *screen, int iconified);
void swift_callback_buffer_resize(GLFWwindow *screen, int width, int height);
void swift_callback_cursor_entered(GLFWwindow *screen, int entered);
void swift_callback_drops(GLFWwindow *screen, int count, const char **paths);
#endif /* SWIFT_SYS_CALLBACKS_H */
